﻿ThisAppName := "KMCustomizer"
ShowSplashImage(ThisAppName . "を設定しています")
;================================================================= 環境定義
#InstallKeybdHook
#UseHook
#MaxHotkeysPerInterval 200
#HotkeyInterval 200
;SendMode, Input ;これを有効にすると、一部環境でリストビューをクリックした時点でハングアップするので無効にする
;-------------------------------------- ウィンドウタイトルの検索方法（中間一致）
SetTitleMatchMode, 2
;-------------------------------------- Sendコマンドの間隔を指定（SendMode, Inputが使えないので代わりに間隔を開けない-1を指定）
;SetWinDelay, 300
SetKeyDelay, -1
;-------------------------------------- ファイル名の定義
Global IniFileName
IniFileName = %A_ScriptDir%\config\%A_ComputerName%_%A_UserName%.ini
;-------------------------------------- キー配列等の変数定義
Global key_asign := Object()
Global key_single := Object()
Global key_lshift := Object()
Global key_rshift := Object()
Global key_special := Object()
Global key_henkan := Object()
Global key_henkan_alt := Object()
Global key_henkan_shift := Object()
Global key_muhenkan := Object()
Global key_muhenkan_alt := Object()
Global key_muhenkan_shift := Object()
Global key_appskey := Object()
Global key_appskey_alt := Object()
Global key_appskey_shift := Object()
Global task_class := Object()
Global task_name := Object()
Global task_title := Object()
Global task_shortcut := Object()
;Global task_cmd := Object()
Global task_lancher_name := Object()
Global task_style := Object()
Global task_full_path := Object()
;-------------------------------------- タスク切替の変数定義
task_list := Object()
task_list_stock := Object()
task_list_before := Object()
task_next_activate_ix := Object()
;-------------------------------------- タスクトレイ収納の変数定義
task_active_id := Object()
task_active_tl := Object()
task_hidden_ct := 0
tray_menu_name := "タスクトレイ収納ウィンドウ"
tray_menu_all_restore := "すべて戻す"
;-------------------------------------- すべてのウィンドウを最小化の変数定義
Global BeforMinAllWinId := Object()
Global BeforMinAllWinAt := Object()
Global BeforMinAllWinCt := 0
;-------------------------------------- スタートボタン上のホイール回転ですべてのウィンドウを最小化/元に戻すときに使用する変数の定義
Global active_win_id_mem
;================================================================= 関数・サブルーチンをインクルード
;-------------------------------------- iniファイル（iniファイル操作より先にインクルードする）
#Include %A_ScriptDir%\SubINI.ahk
;================================================================= トレイメニューの構築
Menu Tray, Add, About, ShowAbout
Menu Tray, Add, Help, ShowHelp
Menu TRAY, Add	;区切り線
Menu Tray, Add, 再起動, ReloadApplication
Menu Tray, Add, 一時停止, SuspendApplication
Menu TRAY, Add	;区切り線
Menu 設定, Add, 環境設定
Menu 設定, Add, キー配列設定
Menu 設定, Add, マウス拡張設定
Menu 設定, Add, マウスジェスチャー設定
Menu Tray, Add, 設定, :設定
Menu TRAY, Add	;区切り線
Menu Tray, Add, 終了, ExitApplication
Menu Tray, NoStandard
Menu Tray, UnCheck, 一時停止
;================================================================= 初回起動時はiniファイルを自動作成する
IniRead,strWrk,%IniFileName%,IME,DirectTypeJpnChrMode,-1
If (strWrk == -1) {
	;--------------- 初回起動時はiniファイルを自動作成する
	Filecopy,%A_ScriptDir%\config\default.ini,%IniFileName%
}
;================================================================= タスクトレイに収納したアプリを表示するトレイメニューをiniファイルから構築する
Loop {
	;--------------- iniファイルを読み込む
	IniRead,ttm_id,%IniFileName%,HIDDEN_APP,Id%A_Index%,-1
	IniRead,ttm_tl,%IniFileName%,HIDDEN_APP,Title%A_Index%,-1
	If (ttm_id == -1) {
		Break
	}
	;--------------- iniファイルに保存されていたIDを持つウィンドウが存在するか確認する
	DetectHiddenWindows, On
	IfWinExist, ahk_id %ttm_id%
	{
		;--------------- 存在する場合はiniファイルの情報を配列に格納する
		task_hidden_ct += 1
		task_active_id[task_hidden_ct] := ttm_id
		task_active_tl[task_hidden_ct] := ttm_tl
	}
}
DetectHiddenWindows, Off
;--------------- 配列からトレイメニューとiniファイルを構築する
Gosub BuildMinToTaskTrayMenu
;================================================================= ダイレクト日本語入力モードの設定
Global DirTypJpnChrMode
IniRead,DirTypJpnChrMode,%IniFileName%,IME,DirectTypeJpnChrMode,-1
;-------------------------------------- アイコンロード
If (DirTypJpnChrMode == 1) {
	IMEicon = icon\on.ico
}Else{
	IMEicon = icon\off.ico
}
Menu TRAY,Icon,%A_ScriptDir%\%IMEicon%
;================================================================= オートIMEオン除外アプリ設定
;-------------------------------------- オートIMEオン除外アプリ情報を取得しグループに追加する
loop {
	IniRead,NotAutoIMEonAppExe_ini,%IniFileName%,NOT_AUTO_IMEON_APP,NotAutoIMEonAppExe%A_Index%,-1
	If (NotAutoIMEonAppExe_ini == -1) {
		Break
	}
	IniRead,NotAutoIMEonAppName_ini,%IniFileName%,NOT_AUTO_IMEON_APP,NotAutoIMEonAppName%A_Index%,-1
	If (NotAutoIMEonAppName_ini == -1) {
		NotAutoIMEonAppName_ini := ""
	}
	GroupAdd NotAutoIMEonApp,ahk_exe %NotAutoIMEonAppExe_ini%,%NotAutoIMEonAppName_ini%
}
;================================================================= モード切替通知設定
IniRead,OnChangeModeBeep,%IniFileName%,CHANGE_MODE_NOTIFY,OnChangeModeBeep,1
IniRead,OnChangeModeToolTip,%IniFileName%,CHANGE_MODE_NOTIFY,OnChangeModeToolTip,1
IniRead,OnChangeModeToolTipDspTime,%IniFileName%,CHANGE_MODE_NOTIFY,OnChangeModeToolTipDspTime,800
;================================================================= タスク切替設定
IniRead,SplitTaskSwitcher,%IniFileName%,TASK_SWITCH,SplitTaskSwitcher,0
;================================================================= キー配列＆設定
ini_file_name = %IniFileName%
ReadIniKeyhairetsu(ini_file_name,0)
;================================================================= マウスボタン拡張設定
IniRead,LbuttonRbutton,%IniFileName%,MOUSEBUTTON,Lbutton_Rbutton,""
IniRead,LbuttonMbutton,%IniFileName%,MOUSEBUTTON,Lbutton_Mbutton,""
IniRead,LbuttonWheelUp,%IniFileName%,MOUSEBUTTON,Lbutton_WheelUp,""
IniRead,LbuttonWheelDn,%IniFileName%,MOUSEBUTTON,Lbutton_WheelDn,""
IniRead,LbuttonXbutton1,%IniFileName%,MOUSEBUTTON,Lbutton_Xbutton1,""
IniRead,LbuttonXbutton2,%IniFileName%,MOUSEBUTTON,Lbutton_Xbutton2,""
IniRead,MbuttonLbutton,%IniFileName%,MOUSEBUTTON,Mbutton_Lbutton,""
IniRead,MbuttonRbutton,%IniFileName%,MOUSEBUTTON,Mbutton_Rbutton,""
IniRead,MbuttonWheelUp,%IniFileName%,MOUSEBUTTON,Mbutton_WheelUp,""
IniRead,MbuttonWheelDn,%IniFileName%,MOUSEBUTTON,Mbutton_WheelDn,""
IniRead,MbuttonXbutton1,%IniFileName%,MOUSEBUTTON,Mbutton_Xbutton1,""
IniRead,MbuttonXbutton2,%IniFileName%,MOUSEBUTTON,Mbutton_Xbutton2,""
IniRead,RbuttonLbutton,%IniFileName%,MOUSEBUTTON,Rbutton_Lbutton,""
IniRead,RbuttonMbutton,%IniFileName%,MOUSEBUTTON,Rbutton_Mbutton,""
IniRead,RbuttonWheelUp,%IniFileName%,MOUSEBUTTON,Rbutton_WheelUp,""
IniRead,RbuttonWheelDn,%IniFileName%,MOUSEBUTTON,Rbutton_WheelDn,""
IniRead,RbuttonXbutton1,%IniFileName%,MOUSEBUTTON,Rbutton_Xbutton1,""
IniRead,RbuttonXbutton2,%IniFileName%,MOUSEBUTTON,Rbutton_Xbutton2,""
IniRead,Xbutton1Lbutton,%IniFileName%,MOUSEBUTTON,Xbutton1_Lbutton,""
IniRead,Xbutton1Mbutton,%IniFileName%,MOUSEBUTTON,Xbutton1_Mbutton,""
IniRead,Xbutton1Rbutton,%IniFileName%,MOUSEBUTTON,Xbutton1_Rbutton,""
IniRead,Xbutton1WheelUp,%IniFileName%,MOUSEBUTTON,Xbutton1_WheelUp,""
IniRead,Xbutton1WheelDn,%IniFileName%,MOUSEBUTTON,Xbutton1_WheelDn,""
IniRead,Xbutton2Lbutton,%IniFileName%,MOUSEBUTTON,Xbutton2_Lbutton,""
IniRead,Xbutton2Mbutton,%IniFileName%,MOUSEBUTTON,Xbutton2_Mbutton,""
IniRead,Xbutton2Rbutton,%IniFileName%,MOUSEBUTTON,Xbutton2_Rbutton,""
IniRead,Xbutton2WheelUp,%IniFileName%,MOUSEBUTTON,Xbutton2_WheelUp,""
IniRead,Xbutton2WheelDn,%IniFileName%,MOUSEBUTTON,Xbutton2_WheelDn,""
IniRead,LMbuttonRbutton,%IniFileName%,MOUSEBUTTON,LMbutton_Rbutton,""
IniRead,MRbuttonLbutton,%IniFileName%,MOUSEBUTTON,MRbutton_Lbutton,""
IniRead,LRbuttonMbutton,%IniFileName%,MOUSEBUTTON,LRbutton_Mbutton,""
IniRead,LRbuttonWheelUp,%IniFileName%,MOUSEBUTTON,LRbutton_WheelUp,""
IniRead,LRbuttonWheelDn,%IniFileName%,MOUSEBUTTON,LRbutton_WheelDn,""
IniRead,Xbutton1,%IniFileName%,MOUSEBUTTON,Xbutton1,""
IniRead,Xbutton2,%IniFileName%,MOUSEBUTTON,Xbutton2,""
;================================================================= マウスホイール拡張設定
IniRead,WhSpAcc,%IniFileName%,MOUSEWHEEL,WhSpeedAcc,0
IniRead,WhSpAccMax,%IniFileName%,MOUSEWHEEL,WhSpeedAccMax,1
IniRead,WhSpAccMin,%IniFileName%,MOUSEWHEEL,WhSpeedAccMin,1
IniRead,WhSpAccSen,%IniFileName%,MOUSEWHEEL,WhSpeedAccSen,20
IniRead,ChangeVolumeOnTray,%IniFileName%,MOUSEWHEEL,ChangeVolumeOnTray,0
IniRead,EnableHorScroll,%IniFileName%,MOUSEWHEEL,EnableHorScroll,0
;================================================================= くるくるスクロール設定
IniRead,KuruHigh,%IniFileName%,KURUKURU,KurukuruHigh,3
IniRead,KuruLow,%IniFileName%,KURUKURU,KurukuruLow,1
IniRead,KuruSen,%IniFileName%,KURUKURU,KurukuruSen,2
IniRead,KuruTimeout,%IniFileName%,KURUKURU,KurukuruTimeout,50
;================================================================= トラックボールでスクロール
IniRead,EnableTrackBallScroll,%IniFileName%,TrackBallScroll,EnableTrackBallScroll,1
IniRead,TrackBallScrollAcc,%IniFileName%,TrackBallScroll,TrackBallScrollAcc,-1
IniRead,TrackBallScrollSen,%IniFileName%,TrackBallScroll,TrackBallScrollSen,5
;================================================================= マウスでウィンドウ操作設定を保存する
IniRead,EnableMinTTrayByMButton,%IniFileName%,OPEWINBYMOUSE,EnableMinTTrayByMButton,1
IniRead,EnableResizeByWheel,%IniFileName%,OPEWINBYMOUSE,EnableResizeByWheel,1
IniRead,ActvOnWheel,%IniFileName%,OPEWINBYMOUSE,ActivateOnWheel,1
IniRead,EnableMinAllByWheelOnStBtn,%IniFileName%,OPEWINBYMOUSE,EnableMinAllByWheelOnStBtn,1
IniRead,MinimizeByWheelOnTaskIcon,%IniFileName%,OPEWINBYMOUSE,MinimizeByWheelOnTaskIcon,1
;================================================================= マウスジェスチャー設定
CoordMode,Mouse,Screen
MG_GridWinName := "MouseGesture"
MG_GridImgName = %A_ScriptDir%\img\mg_grid.png
MG_GridCelImgName = %A_ScriptDir%\img\mg_grid_cel.png
MG_GridImgSize := 316
MG_CelSize := 63
MG_CelOffset := 157
MG_CelCount := 25
MG_String := Object()
MG_Command := Object()
MG_AppName := Object()
MG_AppNeedTitle := Object()
;--------------- マウスジェスチャー・グリッドを表示するGUI画面を定義する（+E0x00020020はクリックスル―:半透明にすると有効になる）
;Gui, MG_Grid: New, +AlwaysOnTop +ToolWindow -Caption -Border +E0x00020020
Gui, MG_Grid: New, +AlwaysOnTop +ToolWindow -Caption -Border
Gui, MG_Grid: Font, s10 ;Bold
Gui, MG_Grid: Add, Picture, X0 Y0, %MG_GridImgName%
Gui, MG_Grid: Add, Picture, X%MG_GridImgSize% Y%MG_GridImgSize% vMG_SelectedCel, %MG_GridCelImgName%
;--------------- iniファイルからマウスジェスチャー情報を取得し配列に格納する
Loop {
	;--------------- 登録されているマウスジェスチャー名を取得する
	IniRead,mg_name,%IniFileName%,MOUSEGESTURE_NAME,MgName%A_Index%,-1
	If (mg_name == -1) {
		Break
	}
	;--------------- マウスジェスチャーの機能名とコマンド内容を取得する
	Loop {
		IniRead,mg_str,%IniFileName%,MOUSEGESTURE_%mg_name%,MgStr%A_Index%,-1
		IniRead,mg_cmd,%IniFileName%,MOUSEGESTURE_%mg_name%,MgCmd%A_Index%,-1
		If (mg_str == -1) {
			Break
		}
		MG_String[mg_name,A_Index] := mg_str
		MG_Command[mg_name,A_Index] := mg_cmd
	}
}
;--------------- iniファイルからマウスジェスチャーを割当てたアプリ情報を取得し配列に格納する
Loop {
	IniRead,mg_app_name,%IniFileName%,MOUSEGESTURE_APP,MgAppName%A_Index%,-1
	If (mg_app_name == -1) {
		Break
	}
	IniRead,mg_app_title,%IniFileName%,MOUSEGESTURE_APP,MgAppTitle%A_Index%,-1
	;--------------- アプリタイトルも指定されているか確認する
	If (StrLen(mg_app_title) > 0) {
		MG_AppNeedTitle[mg_app_name] := 1
	}Else{
		MG_AppNeedTitle[mg_app_name] := 0
	}
	IniRead,mg_assign,%IniFileName%,MOUSEGESTURE_APP_%mg_app_name%%mg_app_title%,MgAssign,-1
	ix = %mg_app_name%%mg_app_title%
	MG_AppName[ix] := mg_assign
}
Loop %MG_CelCount% {
	;--------------- マウスジェスチャーのコマンド名称表示するテキストエリアをグリッド上に配置する
	MG_xCelNo := Mod(A_Index - 1,5)
	MG_yCelNo := (A_Index - 1) // 5
	MG_GridX := MG_xCelNo * MG_CelSize + 5
	MG_GridY := MG_yCelNo * MG_CelSize + 5
	MG_GridW := MG_CelSize - 10
	Gui, MG_Grid: Add, Text, vMG_CellName%A_Index% X%MG_GridX% Y%MG_GridY% W%MG_GridW% H%MG_GridW% Center BackgroundTrans, dummy
}
;--------------- マウスジェスチャー・グリッドを表示する
;Gui, MG_Grid: Show, W%MG_GridImgSize% H%MG_GridImgSize% X9999 Y9999 Minimize, %MG_GridWinName%
;--------------- マウスジェスチャー・グリッドを表示するGUI画面のIDを取得する
;WinGet MG_TraceID, ID, %MG_GridWinName%
;--------------- マウスジェスチャー・グリッドを表示するGUI画面を透過型にする
;WinSet Transparent, 254, ahk_id %MG_TraceID%
;Gui, MG_Grid: Show, W%MG_GridImgSize% H%MG_GridImgSize% X9999 Y9999 Restore, %MG_GridWinName%
;-------------------------------------- 右クリックで対象ウィンドウを変更するアプリ情報を取得しグループに追加する
loop {
	IniRead,MgRClickAppName_ini,%IniFileName%,MOUSEGESTURE_RCLICK_APP,MgRClickAppName%A_Index%,-1
	If (MgRClickAppName_ini == -1) {
		Break
	}
	IniRead,MgRClickAppTitle_ini,%IniFileName%,MOUSEGESTURE_RCLICK_APP,MgRClickAppTitle%A_Index%,-1
	If (MgRClickAppTitle_ini == -1) {
		MgRClickAppTitle_ini := ""
	}
	GroupAdd MG_RClickApp,ahk_exe %MgRClickAppName_ini%, %MgRClickAppTitle_ini%
}
;================================================================= 準備完了通知
;------------------------------ 通知音をならす
If (OnChangeModeBeep == 1) {
	SoundBeep,800,100
}
;------------------------------ 通知メッセージを表示する
;If (OnChangeModeToolTip == 1) {
	ShowSplashImage(ThisAppName . "が使用可能になりました")
	SetTimer RemoveSplashImage,2000
;}
;================================================================= 関数・サブルーチンをインクルード
;-------------------------------------- マウス操作（一番最初にインクルードすること）
#Include %A_ScriptDir%\SubMouse.ahk
;-------------------------------------- タスク制御
#Include %A_ScriptDir%\SubTask.ahk
#Include %A_ScriptDir%\SubTaskSwitcher.ahk
;-------------------------------------- About & Help
#Include %A_ScriptDir%\SubAboutAndHelp.ahk
;-------------------------------------- ツール
#Include %A_ScriptDir%\SubTool.ahk
;-------------------------------------- IME
#Include %A_ScriptDir%\SubIME.ahk
;-------------------------------------- クリップボード
;#Include %A_ScriptDir%\SubClipboard.ahk
;-------------------------------------- キー送信
#Include %A_ScriptDir%\SubSendKey.ahk
;-------------------------------------- 機能設定
#Include %A_ScriptDir%\SubConfigPanel.ahk
;-------------------------------------- キー配列設定
#Include %A_ScriptDir%\SubConfigKeyhairetsu.ahk
;-------------------------------------- キー配列プリセット設定
#Include %A_ScriptDir%\SubConfigKeyPreset.ahk
;-------------------------------------- マウス拡張設定
#Include %A_ScriptDir%\SubConfigMouse.ahk
#Include %A_ScriptDir%\SubConfigMouseGesture.ahk
;================================================================= スクリプトをリロードする
ReloadApplication:
	Reload
Return
;================================================================= スクリプトを一時停止する
SuspendApplication:
	Menu Tray,ToggleCheck, 一時停止
	If (A_IsSuspended == 1) {
		Suspend Off
	}Else{
		Suspend On
	}
Return
;================================================================= スクリプトを終了する
ExitApplication:
	Msgbox 4,　,アプリケーションを終了しますか？
	IfMsgBox, Yes
	{
		Gosub RestoreAllWinFromTaskTray
		ExitApp
	}
Return
;================================================================= キー拡張
;-------------------------------------- 入力スタイルに応じてキー入力内容を変更する（単独打鍵）
1::
2::
3::
4::
5::
6::
7::
8::
9::
0::
-::
^::
\::
q::
w::
e::
r::
t::
y::
u::
i::
o::
p::
@::
[::
a::
s::
d::
f::
g::
h::
j::
k::
l::
sc027::
sc028::
]::
z::
x::
c::
v::
b::
n::
m::
sc033::
sc034::
/::
sc073::
sc079::
Space up::
sc07B::
sc070::
AppsKey::
Enter::
f24::
Esc::
;sc029::
;sc029::
;-------------------------- Tabキーをキー割り当ての対象にするとAlt+Shift+Tabが効かなくなるので除外
;Tab::
BS::
Ins::
Delete::
Home::
End::
PgUp::
PgDn::
Left::
Right::
Up::
Down::
F1::
F2::
F3::
F4::
F5::
F6::
F7::
F8::
F9::
F10::
F11::
F12::
PrintScreen::
ScrollLock::
Pause::
	Gosub SendSingleKey
Return
;-------------------------------------- LWinのトラックボールスクロール対応
LWin up::
	If (NoLWin == 1) {
		NoLWin := 0
	}Else{
		Gosub SendSingleKey
	}
Return
;-------------------------------------- RWinのトラックボールスクロール対応
RWin up::
	If (NoRWin == 1) {
		NoRWin := 0
	}Else{
		Gosub SendSingleKey
	}
Return
;-------------------------------------- 入力スタイルに応じてキー入力内容を変更する（LShift）
LShift & 1::
LShift & 2::
LShift & 3::
LShift & 4::
LShift & 5::
LShift & 6::
LShift & 7::
LShift & 8::
LShift & 9::
LShift & 0::
LShift & -::
LShift & ^::
LShift & \::
LShift & q::
LShift & w::
LShift & e::
LShift & r::
LShift & t::
LShift & y::
LShift & u::
LShift & i::
LShift & o::
LShift & p::
LShift & @::
LShift & [::
LShift & a::
LShift & s::
LShift & d::
LShift & f::
LShift & g::
LShift & h::
LShift & j::
LShift & k::
LShift & l::
LShift & sc027::
LShift & sc028::
LShift & ]::
LShift & z::
LShift & x::
LShift & c::
LShift & v::
LShift & b::
LShift & n::
LShift & m::
LShift & sc033::
LShift & sc034::
LShift & /::
LShift & sc073::
LShift & sc079::
LShift & Space::
LShift & sc07B::
LShift & sc070::
LShift & LWin up::
LShift & RWin up::
LShift & AppsKey::
LShift & Enter::
LShift & f24::
LShift & Esc::
;LShift & sc029::
;LShift & sc029::
;LShift & Tab::
LShift & BS::
LShift & Ins::
LShift & Delete::
LShift & Home::
LShift & End::
LShift & PgUp::
LShift & PgDn::
LShift & Left::
LShift & Right::
LShift & Up::
LShift & Down::
LShift & F1::
LShift & F2::
LShift & F3::
LShift & F4::
LShift & F5::
LShift & F6::
LShift & F7::
LShift & F8::
LShift & F9::
LShift & F10::
LShift & F11::
LShift & F12::
LShift & PrintScreen::
LShift & ScrollLock::
LShift & Pause::
	Gosub SendLShiftKey
Return
;-------------------------------------- 入力スタイルに応じてキー入力内容を変更する（RShift）
RShift & 1::
RShift & 2::
RShift & 3::
RShift & 4::
RShift & 5::
RShift & 6::
RShift & 7::
RShift & 8::
RShift & 9::
RShift & 0::
RShift & -::
RShift & ^::
RShift & \::
RShift & q::
RShift & w::
RShift & e::
RShift & r::
RShift & t::
RShift & y::
RShift & u::
RShift & i::
RShift & o::
RShift & p::
RShift & @::
RShift & [::
RShift & a::
RShift & s::
RShift & d::
RShift & f::
RShift & g::
RShift & h::
RShift & j::
RShift & k::
RShift & l::
RShift & sc027::
RShift & sc028::
RShift & ]::
RShift & z::
RShift & x::
RShift & c::
RShift & v::
RShift & b::
RShift & n::
RShift & m::
RShift & sc033::
RShift & sc034::
RShift & /::
RShift & sc073::
RShift & sc079::
RShift & Space::
RShift & sc07B::
RShift & sc070::
RShift & LWin up::
RShift & RWin up::
RShift & AppsKey::
RShift & Enter::
RShift & f24::
RShift & Esc::
;RShift & sc029::
;RShift & sc029::
;RShift & Tab::
RShift & BS::
RShift & Ins::
RShift & Delete::
RShift & Home::
RShift & End::
RShift & PgUp::
RShift & PgDn::
RShift & Left::
RShift & Right::
RShift & Up::
RShift & Down::
RShift & F1::
RShift & F2::
RShift & F3::
RShift & F4::
RShift & F5::
RShift & F6::
RShift & F7::
RShift & F8::
RShift & F9::
RShift & F10::
RShift & F11::
RShift & F12::
RShift & PrintScreen::
RShift & ScrollLock::
RShift & Pause::
	Gosub SendRShiftKey
Return
;-------------------------------------- 入力スタイルに応じてキー入力内容を変更する（スペシャルキー）
f24 & 1::
f24 & 2::
f24 & 3::
f24 & 4::
f24 & 5::
f24 & 6::
f24 & 7::
f24 & 8::
f24 & 9::
f24 & 0::
f24 & -::
f24 & ^::
f24 & \::
f24 & q::
f24 & w::
f24 & e::
f24 & r::
f24 & t::
f24 & y::
f24 & u::
f24 & i::
f24 & o::
f24 & p::
f24 & @::
f24 & [::
f24 & a::
f24 & s::
f24 & d::
f24 & f::
f24 & g::
f24 & h::
f24 & j::
f24 & k::
f24 & l::
f24 & sc027::
f24 & sc028::
f24 & ]::
f24 & z::
f24 & x::
f24 & c::
f24 & v::
f24 & b::
f24 & n::
f24 & m::
f24 & sc033::
f24 & sc034::
f24 & /::
f24 & sc073::
f24 & sc079::
f24 & Space::
f24 & sc07B::
f24 & sc070::
f24 & AppsKey::
f24 & Enter::
f24 & Esc::
;f24 & Tab::
f24 & BS::
f24 & Ins::
f24 & Delete::
f24 & Home::
f24 & End::
f24 & PgUp::
f24 & PgDn::
f24 & Left::
f24 & Right::
f24 & Up::
f24 & Down::
f24 & F1::
f24 & F2::
f24 & F3::
f24 & F4::
f24 & F5::
f24 & F6::
f24 & F7::
f24 & F8::
f24 & F9::
f24 & F10::
f24 & F11::
f24 & F12::
f24 & PrintScreen::
f24 & ScrollLock::
f24 & Pause::
	Gosub SendSpecialKey
Return
;-------------------------------------- 入力スタイルに応じてキー入力内容を変更する（変換）
sc079 & 1::
sc079 & 2::
sc079 & 3::
sc079 & 4::
sc079 & 5::
sc079 & 6::
sc079 & 7::
sc079 & 8::
sc079 & 9::
sc079 & 0::
sc079 & -::
sc079 & ^::
sc079 & \::
sc079 & q::
sc079 & w::
sc079 & e::
sc079 & r::
sc079 & t::
sc079 & y::
sc079 & u::
sc079 & i::
sc079 & o::
sc079 & p::
sc079 & @::
sc079 & [::
sc079 & a::
sc079 & s::
sc079 & d::
sc079 & f::
sc079 & g::
sc079 & h::
sc079 & j::
sc079 & k::
sc079 & l::
sc079 & sc027::
sc079 & sc028::
sc079 & ]::
sc079 & z::
sc079 & x::
sc079 & c::
sc079 & v::
sc079 & b::
sc079 & n::
sc079 & m::
sc079 & sc033::
sc079 & sc034::
sc079 & /::
sc079 & sc073::
sc079 & Space::
sc079 & sc07B::
sc079 & sc070::
sc079 & AppsKey::
sc079 & Enter::
sc079 & Esc::
;sc079 & Tab::
sc079 & BS::
sc079 & Ins::
sc079 & Delete::
sc079 & Home::
sc079 & End::
sc079 & PgUp::
sc079 & PgDn::
sc079 & Left::
sc079 & Right::
sc079 & Up::
sc079 & Down::
sc079 & F1::
sc079 & F2::
sc079 & F3::
sc079 & F4::
sc079 & F5::
sc079 & F6::
sc079 & F7::
sc079 & F8::
sc079 & F9::
sc079 & F10::
sc079 & F11::
sc079 & F12::
sc079 & PrintScreen::
sc079 & ScrollLock::
sc079 & Pause::
	Gosub SendHenkanKey
Return
;-------------------------------------- 入力スタイルに応じてキー入力内容を変更する（無変換）
sc07B & 1::
sc07B & 2::
sc07B & 3::
sc07B & 4::
sc07B & 5::
sc07B & 6::
sc07B & 7::
sc07B & 8::
sc07B & 9::
sc07B & 0::
sc07B & -::
sc07B & ^::
sc07B & \::
sc07B & q::
sc07B & w::
sc07B & e::
sc07B & r::
sc07B & t::
sc07B & y::
sc07B & u::
sc07B & i::
sc07B & o::
sc07B & p::
sc07B & @::
sc07B & [::
sc07B & a::
sc07B & s::
sc07B & d::
sc07B & f::
sc07B & g::
sc07B & h::
sc07B & j::
sc07B & k::
sc07B & l::
sc07B & sc027::
sc07B & sc028::
sc07B & ]::
sc07B & z::
sc07B & x::
sc07B & c::
sc07B & v::
sc07B & b::
sc07B & n::
sc07B & m::
sc07B & sc033::
sc07B & sc034::
sc07B & /::
sc07B & sc073::
sc07B & sc079::
sc07B & Space::
sc07B & sc070::
sc07B & AppsKey::
sc07B & Enter::
sc07B & Esc::
;sc07B & sc029::
;sc07B & sc029::
;sc07B & Tab::
sc07B & BS::
sc07B & Ins::
sc07B & Delete::
sc07B & Home::
sc07B & End::
sc07B & PgUp::
sc07B & PgDn::
sc07B & Left::
sc07B & Right::
sc07B & Up::
sc07B & Down::
sc07B & F1::
sc07B & F2::
sc07B & F3::
sc07B & F4::
sc07B & F5::
sc07B & F6::
sc07B & F7::
sc07B & F8::
sc07B & F9::
sc07B & F10::
sc07B & F11::
sc07B & F12::
sc07B & PrintScreen::
sc07B & ScrollLock::
sc07B & Pause::
	Gosub SendMuhenkanKey
Return
;-------------------------------------- 入力スタイルに応じてキー入力内容を変更する（AppsKey）
AppsKey & 1::
AppsKey & 2::
AppsKey & 3::
AppsKey & 4::
AppsKey & 5::
AppsKey & 6::
AppsKey & 7::
AppsKey & 8::
AppsKey & 9::
AppsKey & 0::
AppsKey & -::
AppsKey & ^::
AppsKey & \::
AppsKey & q::
AppsKey & w::
AppsKey & e::
AppsKey & r::
AppsKey & t::
AppsKey & y::
AppsKey & u::
AppsKey & i::
AppsKey & o::
AppsKey & p::
AppsKey & @::
AppsKey & [::
AppsKey & a::
AppsKey & s::
AppsKey & d::
AppsKey & f::
AppsKey & g::
AppsKey & h::
AppsKey & j::
AppsKey & k::
AppsKey & l::
AppsKey & sc027::
AppsKey & sc028::
AppsKey & ]::
AppsKey & z::
AppsKey & x::
AppsKey & c::
AppsKey & v::
AppsKey & b::
AppsKey & n::
AppsKey & m::
AppsKey & sc033::
AppsKey & sc034::
AppsKey & /::
AppsKey & sc073::
AppsKey & sc079::
AppsKey & Space::
AppsKey & sc07B::
AppsKey & sc070::
AppsKey & Enter::
AppsKey & Esc::
;AppsKey & Tab::
AppsKey & BS::
AppsKey & Ins::
AppsKey & Delete::
AppsKey & Home::
AppsKey & End::
AppsKey & PgUp::
AppsKey & PgDn::
AppsKey & Left::
AppsKey & Right::
AppsKey & Up::
AppsKey & Down::
AppsKey & F1::
AppsKey & F2::
AppsKey & F3::
AppsKey & F4::
AppsKey & F5::
AppsKey & F6::
AppsKey & F7::
AppsKey & F8::
AppsKey & F9::
AppsKey & F10::
AppsKey & F11::
AppsKey & F12::
AppsKey & PrintScreen::
AppsKey & ScrollLock::
AppsKey & Pause::
	Gosub SendAppsKey
Return
;================================================================= Ctrl　
~Ctrl::
	If (GetKeyState("Space","p")) {
		;--------------- Spaceキーを押しながらCtrlキーを押したときは、半角Spaceを送る
		If (DirTypJpnChrMode == 1) {
			;--------------- ダイレクト日本語モードONのときは、半角Spaceを送る
			Send +{F13}{Space}
		}Else{
			;--------------- ダイレクト日本語モードOFFのときは、全角Spaceを送る
			Send ^{F13}{Space}
		}
		;--------------- Space Upとの二重起動を避けるため変数に値をセットする
		xInput := 1
	}
Return
;================================================================= LButton
;各種設定画面のタイトルバーの閉じるボタンが押せなくなるので、必ず閉じるボタンを追加すること
LButton::
	If (GetKeyState("RButton","p") || GetKeyState("MButton","p") || GetKeyState("XButton1","p") || GetKeyState("XButton2","p")) {
		;--------------- マウス拡張機能が実行されたときは何もしない
		Return
	}Else{
		Send {LButton Down}
	}
Return
;================================================================= LButton up
~LButton up::
	;--------------- マウスジェスチャー起動後のクリック防止判定変数をセットする
	NoMbutton := 0
	NoXbutton1 := 0
	NoXbutton2 := 0
	;--------------- 中と右ボタンを押しながらマウス拡張機能が実行されたとき
	If (GetKeyState("MButton","p") && GetKeyState("RButton","p")) {
		;--------------- マウスジェスチャー実行可能状態をオフにする
		enable_mouse_ges := 0
		;--------------- マウスジェスチャーキャンセル変数をオンにする
		cancel_mouse_ges := 1
		;--------------- マウスカーソル下のウィンドウをアクティブにする
		ActivateUnderMouseWindow()
		;--------------- iniファイルで指定されたショートカットを実行する
		key := MRbuttonLbutton
		Gosub SendKeyOrSearch
		Return
	}
	;--------------- マウスジェスチャーキャンセル変数がオンのときはなにもしない
	If (cancel_mouse_ges == 1) {
		;--------------- マウスジェスチャーキャンセル変数をオフにする
		cancel_mouse_ges := 0
		Return
	}
	;--------------- 右ボタンを押しながらのマウス拡張機能が実行されたとき
	If (GetKeyState("RButton","p")) {
		;--------------- マウスジェスチャー・グリッドが表示されていたら隠す
		If (MG_Disp == 1) {
			;--------------- マウスジェスチャー・グリッドを隠す（「最小化→元に戻す」にしないと外枠が表示されてしまう）
			Gui, MG_Grid: Show, W%MG_GridImgSize% H%MG_GridImgSize% X%ShowPosX% Y%ShowPosY% Minimize, %MG_GridWinName%
			Gui, MG_Grid: Show, W%MG_GridImgSize% H%MG_GridImgSize% X%ShowPosX% Y%ShowPosY% Restore, %MG_GridWinName%
			Gui, MG_Grid: Hide
			Return
		}
		;--------------- マウスジェスチャー実行可能状態をオフにする
		enable_mouse_ges := 0
		;--------------- マウスカーソル下のウィンドウをアクティブにする
		ActivateUnderMouseWindow()
		;--------------- iniファイルで指定されたショートカットを実行する
		key := RbuttonLbutton
		Gosub SendKeyOrSearch
		Return
	}
	;--------------- 中ボタンを押しながらのマウス拡張機能が実行されたとき
	If (GetKeyState("MButton","p")) {
		;--------------- マウスカーソル下のウィンドウをアクティブにする
		ActivateUnderMouseWindow()
		;--------------- iniファイルで指定されたショートカットを実行する
		key := MbuttonLbutton
		Gosub SendKeyOrSearch
		;--------------- マウスジェスチャー起動後の中クリック防止判定変数をセットする
		NoMbutton := 1
		Return
	}
	;--------------- X1ボタンを押しながらのマウス拡張機能が実行されたとき
	If (GetKeyState("XButton1","p")) {
		;--------------- マウスカーソル下のウィンドウをアクティブにする
		ActivateUnderMouseWindow()
		;--------------- iniファイルで指定されたショートカットを実行する
		key := Xbutton1Lbutton
		Gosub SendKeyOrSearch
		;--------------- マウスジェスチャー起動後の中クリック防止判定変数をセットする
		NoXbutton1 := 1
		Return
	}
	;--------------- X1ボタンを押しながらのマウス拡張機能が実行されたとき
	If (GetKeyState("XButton2","p")) {
		;--------------- マウスカーソル下のウィンドウをアクティブにする
		ActivateUnderMouseWindow()
		;--------------- iniファイルで指定されたショートカットを実行する
		key := Xbutton2Lbutton
		Gosub SendKeyOrSearch
		;--------------- マウスジェスチャー起動後の中クリック防止判定変数をセットする
		NoXbutton2 := 1
		Return
	}
	;--------------- 左ボタンを押した時点で左ダウンさせているが、ここでの解除は不要
	;Send {LButton Up}
Return
;================================================================= RButton
RButton::
	;--------------- タスクバー領域でボタンが押されたか判定する
	Res := IsTaskbarControlUnderMouse(win_id,WinCtrlClass)
	If (Res == 1) {
		;--------------- タスクバー領域でボタンが押されたときは何もせず判定変数をセットする
		RButtonDownlOnTaskbar := 1
		NeedRUp := 0
		enable_mouse_ges := 0
	}Else{
		;--------------- タスクバー領域以外でボタンが押されたときは判定変数をクリアする
		RButtonDownlOnTaskbar := 0
		;--------------- タスクスイッチャーで右クリックしたときは、マウスジェスチャーを無効にする
		If (RBtnDnAtTaskSwitcher == 1) {
			;Send {RButton Down}
			NeedRUp := 1
			enable_mouse_ges := 0
			RBtnDnAtTaskSwitcher := 0
			Return
		}
		;--------------- 他ボタンを起点とするマウスジェスチャー発動時の時は何もしない
		If (GetKeyState("LButton","p") || GetKeyState("MButton","p")) {
			NeedRUp := 0
			enable_mouse_ges := 0
			Return
		}
		If (GetKeyState("sc07B","p") || GetKeyState("sc079","p")) {
			;--------------- 無変換または変換キーを押しながら右ボタンを押したときは右ドラッグを有効にする
			Send {RButton Down}
			NeedRUp := 1
			enable_mouse_ges := 0
		}Else{
			;--------------- 右ボタンを単独で押したときはマウスジェスチャーを有効にする
			NeedRUp := 0
			Gosub EnableMouseGesture
		}
	}
Return
;================================================================= RButton up
RButton up::
	;--------------- マウスジェスチャー起動後のクリック防止判定変数をセットする
	NoMbutton := 0
	NoXbutton1 := 0
	NoXbutton2 := 0
	;--------------- 左と中ボタンを押しながらマウス拡張機能が実行されたとき
	If (GetKeyState("LButton","p") && GetKeyState("MButton","p")) {
		;--------------- マウスジェスチャー実行可能状態をオフにする
		enable_mouse_ges := 0
		;--------------- マウスジェスチャーキャンセル変数をオンにする
		cancel_mouse_ges := 1
		;--------------- マウスカーソル下のウィンドウをアクティブにする
		ActivateUnderMouseWindow()
		;--------------- iniファイルで指定されたショートカットを実行する
		key := LMbuttonRbutton
		Gosub SendKeyOrSearch
		Return
	}
	;--------------- マウスジェスチャーキャンセル変数がオンのときはなにもしない
	If (cancel_mouse_ges == 1) {
		;--------------- マウスジェスチャーキャンセル変数をオフにする
		cancel_mouse_ges := 0
		Return
	}
	;--------------- 左ボタンを押しながらマウス拡張機能が実行されたとき
	If (GetKeyState("LButton","p")) {
		;--------------- マウスジェスチャー実行可能状態をオフにする
		enable_mouse_ges := 0
		;--------------- マウスカーソル下のウィンドウをアクティブにする
		ActivateUnderMouseWindow()
		;--------------- iniファイルで指定されたショートカットを実行する
		key := LbuttonRbutton
		Gosub SendKeyOrSearch
		Return
	}
	;--------------- 中ボタンを押しながらマウス拡張機能が実行されたとき
	If (GetKeyState("MButton","p")) {
		;--------------- マウスジェスチャー実行可能状態をオフにする
		enable_mouse_ges := 0
		;--------------- マウスカーソル下のウィンドウをアクティブにする
		ActivateUnderMouseWindow()
		;--------------- iniファイルで指定されたショートカットを実行する
		key := MbuttonRbutton
		Gosub SendKeyOrSearch
		;--------------- マウスジェスチャー起動後の中クリック防止判定変数をセットする
		NoMbutton := 1
		Return
	}
	;--------------- X1ボタンを押しながらマウス拡張機能が実行されたとき
	If (GetKeyState("XButton1","p")) {
		;--------------- マウスジェスチャー実行可能状態をオフにする
		enable_mouse_ges := 0
		;--------------- マウスカーソル下のウィンドウをアクティブにする
		ActivateUnderMouseWindow()
		;--------------- iniファイルで指定されたショートカットを実行する
		key := Xbutton1Rbutton
		Gosub SendKeyOrSearch
		;--------------- マウスジェスチャー起動後のX1クリック防止判定変数をセットする
		NoXbutton1 := 1
		Return
	}
	;--------------- X2ボタンを押しながらマウス拡張機能が実行されたとき
	If (GetKeyState("XButton2","p")) {
		;--------------- マウスジェスチャー実行可能状態をオフにする
		enable_mouse_ges := 0
		;--------------- マウスカーソル下のウィンドウをアクティブにする
		ActivateUnderMouseWindow()
		;--------------- iniファイルで指定されたショートカットを実行する
		key := Xbutton2Rbutton
		Gosub SendKeyOrSearch
		;--------------- マウスジェスチャー起動後のX2クリック防止判定変数をセットする
		NoXbutton2 := 1
		Return
	}
	;--------------- 直前のホットキーがマウス右ボタンのときはマウスジェスチャーを発動させる
	If (A_PriorHotkey == "RButton") {
		;--------------- マウスジェスチャー対象のときはマウスジェスチャーを発動させる
		If (enable_mouse_ges == 1) {
			MG_Done := 0
			Gosub ExecMouseGesture
			If (MG_Done == 0) {
				;--------------- マウス右ボタンをすぐ離したときは右クリックを送る
				Send {RButton}
			}
		}Else{
			;--------------- マウスジェスチャー対象外のときは右クリックを送る
			Send {RButton}			
		}
	}Else{
		;--------------- 直前のホットキーがマウス右ボタンでないときはマウスジェスチャー実行可能状態をオフにする
		enable_mouse_ges := 0
		;--------------- 右クリックが必要な時は右クリックを送る
		If (NeedRUp == 1) {
			Send {RButton}
		}
	}
Return
;================================================================= MButton
MButton::Return
MButton up::
	;--------------- マウスジェスチャーキャンセル変数がオンのときはなにもしない
	If (cancel_mouse_ges == 1) {
		;--------------- マウスジェスチャーキャンセル変数をオフにする
		cancel_mouse_ges := 0
		Return
	}
	;--------------- 左と右ボタンを押しながらマウス拡張機能が実行されたとき
	If (GetKeyState("LButton","p") && GetKeyState("RButton","p")) {
		;--------------- マウスジェスチャー実行可能状態をオフにする
		enable_mouse_ges := 0
		;--------------- マウスジェスチャーキャンセル変数をオンにする
		cancel_mouse_ges := 1
		;--------------- マウスカーソル下のウィンドウをアクティブにする
		ActivateUnderMouseWindow()
		;--------------- iniファイルで指定されたショートカットを実行する
		key := LRbuttonMbutton
		Gosub SendKeyOrSearch
		Return
	}
	;--------------- 左ボタンを押しながらマウス拡張機能が実行されたとき
	If (GetKeyState("LButton","p")) {
		;--------------- マウスカーソル下のウィンドウをアクティブにする
		ActivateUnderMouseWindow()
		;--------------- iniファイルで指定されたショートカットを実行する
		key := LbuttonMbutton
		Gosub SendKeyOrSearch
		Return
	}
	;--------------- 右ボタンを押しながらマウス拡張機能が実行されたとき
	If (GetKeyState("RButton","p")) {
		;--------------- マウスジェスチャー・グリッドが表示されていたら隠す
		If (MG_Disp == 1) {
			;--------------- マウスジェスチャー・グリッドを隠す（「最小化→元に戻す」にしないと外枠が表示されてしまう）
			Gui, MG_Grid: Show, W%MG_GridImgSize% H%MG_GridImgSize% X%ShowPosX% Y%ShowPosY% Minimize, %MG_GridWinName%
			Gui, MG_Grid: Show, W%MG_GridImgSize% H%MG_GridImgSize% X%ShowPosX% Y%ShowPosY% Restore, %MG_GridWinName%
			Gui, MG_Grid: Hide
			Return
		}
		;--------------- マウスジェスチャー実行可能状態をオフにする
		enable_mouse_ges := 0
		;--------------- マウスカーソル下のウィンドウをアクティブにする
		ActivateUnderMouseWindow()
		;--------------- iniファイルで指定されたショートカットを実行する
		key := RbuttonMbutton
		Gosub SendKeyOrSearch
		;--------------- マウスジェスチャー実行後の中ボタンクリックを抑止する
		NoMbutton := 1
		Return
	}
	;--------------- X1ボタンを押しながらマウス拡張機能が実行されたとき
	If (GetKeyState("XButton1","p")) {
		;--------------- マウスカーソル下のウィンドウをアクティブにする
		ActivateUnderMouseWindow()
		;--------------- iniファイルで指定されたショートカットを実行する
		key := Xbutton1Mbutton
		Gosub SendKeyOrSearch
		;--------------- マウスジェスチャー起動後のX1クリック防止判定変数をセットする
		NoXbutton1 := 1
		Return
	}
	;--------------- X2ボタンを押しながらマウス拡張機能が実行されたとき
	If (GetKeyState("XButton2","p")) {
		;--------------- マウスカーソル下のウィンドウをアクティブにする
		ActivateUnderMouseWindow()
		;--------------- iniファイルで指定されたショートカットを実行する
		key := Xbutton2Mbutton
		Gosub SendKeyOrSearch
		;--------------- マウスジェスチャー起動後のX2クリック防止判定変数をセットする
		NoXbutton2 := 1
		Return
	}
	;--------------- マウスジェスチャー起動後の中クリック防止
	If (NoMbutton == 1) {
		NoMbutton := 0
		Send {MButton Up}
	}Else{
		;--------------- タイトルバーを中ボタンクリックでタスクトレイに収納
		If (EnableMinTTrayByMButton == 1) {
			;--------------- 非アクティブウィンドウのタイトルバーをクリックしたときに、即収納できるように先にクリックを送る
			Send {MButton}
			;--------------- マウスカーソル下がタイトルバーか確認
			Res := IsMouseOnActiveWinTitleBar()
			If (Res == True) {
				Gosub SubMinimizeToTaskTray
			}
		}Else{
			Send {MButton}
		}
	}
Return
;================================================================= XButton1
XButton1::Return
XButton1 up::
	;--------------- マウスカーソル下のウィンドウをアクティブにする
	ActivateUnderMouseWindow()
	;--------------- 左ボタンを押しながらマウス拡張機能が実行されたとき
	If (GetKeyState("LButton","p")) {
		;--------------- マウスジェスチャー起動後のX1クリック防止判定変数をセットする
		NoXbutton1 := 1
		;--------------- iniファイルで指定されたショートカットを実行する
		key := LbuttonXbutton1
		Gosub SendKeyOrSearch
		Return
	}
	;--------------- 中ボタンを押しながらマウス拡張機能が実行されたとき
	If (GetKeyState("MButton","p")) {
		;--------------- マウスジェスチャー起動後のX1クリック防止判定変数をセットする
		NoXbutton1 := 1
		;--------------- iniファイルで指定されたショートカットを実行する
		key := MbuttonXbutton1
		Gosub SendKeyOrSearch
		Return
	}
	;--------------- 右ボタンを押しながらマウス拡張機能が実行されたとき
	If (GetKeyState("RButton","p")) {
		;--------------- マウスジェスチャー起動後のX1クリック防止判定変数をセットする
		NoXbutton1 := 1
		;--------------- iniファイルで指定されたショートカットを実行する
		key := RbuttonXbutton1
		Gosub SendKeyOrSearch
		Return
	}
	;--------------- マウスジェスチャー起動後のX1クリック防止
	If (NoXbutton1 == 1) {
		;--------------- マウスジェスチャー起動後のX1クリック防止
		NoXbutton1 := 0
	}Else{
		;--------------- iniファイルで指定されたショートカットを実行する
		key := XButton1
		Gosub SendKeyOrSearch
	}
Return
;================================================================= XButton2
XButton2::Return
XButton2 up::
	;--------------- マウスカーソル下のウィンドウをアクティブにする
	ActivateUnderMouseWindow()
	;--------------- 左ボタンを押しながらマウス拡張機能が実行されたとき
	If (GetKeyState("LButton","p")) {
		;--------------- マウスジェスチャー起動後のX2クリック防止判定変数をセットする
		NoXbutton2 := 1
		;--------------- iniファイルで指定されたショートカットを実行する
		key := LbuttonXbutton2
		Gosub SendKeyOrSearch
		Return
	}
	;--------------- 中ボタンを押しながらマウス拡張機能が実行されたとき
	If (GetKeyState("MButton","p")) {
		;--------------- マウスジェスチャー起動後のX2クリック防止判定変数をセットする
		NoXbutton2 := 1
		;--------------- iniファイルで指定されたショートカットを実行する
		key := MbuttonXbutton2
		Gosub SendKeyOrSearch
		Return
	}
	;--------------- 右ボタンを押しながらマウス拡張機能が実行されたとき
	If (GetKeyState("RButton","p")) {
		;--------------- マウスジェスチャー起動後のX2クリック防止判定変数をセットする
		NoXbutton2 := 1
		;--------------- iniファイルで指定されたショートカットを実行する
		key := RbuttonXbutton2
		Gosub SendKeyOrSearch
		Return
	}
	;--------------- マウスジェスチャー起動後のX2クリック防止
	If (NoXbutton2 == 1) {
		;--------------- マウスジェスチャー起動後のX2クリック防止
		NoXbutton2 := 0
	}Else{
		;--------------- iniファイルで指定されたショートカットを実行する
		key := XButton2
		Gosub SendKeyOrSearch
	}
Return
;================================================================= Wheel
;-------------------------------------- マウスホイール拡張
WheelUp::
WheelDown::
	;--------------- ホイールタイプをセット
	wheeltype := A_ThisHotkey
	;--------------- マウスホイール回転でウィンドウをアクティブにする
	If (ActvOnWheel == 1) {
		ActivateUnderMouseWindow()
	}
	;--------------- マウスホイールの加速
	If (WhSpAcc == 1) {
		If (A_TimeSincePriorHotkey <= WhSpAccSen) {
			count = %WhSpAccMax%
		}Else{
			count = %WhSpAccMin%
		}
		MouseClick %wheeltype%,,,%count%
	}Else{
		MouseClick %wheeltype%,,,1
	}
Return
;--------------- 左ボタンを押しながらのマウス拡張機能が実行されたとき
~LButton & WheelUp::
	;--------------- マウスホイール回転でウィンドウをアクティブにする
	If (ActvOnWheel == 1) {
		ActivateUnderMouseWindow()
	}
	;--------------- 左と右ボタンを押しながらマウス拡張機能が実行されたとき
	If (GetKeyState("RButton","p")) {
		;--------------- マウスジェスチャーキャンセル変数をオンにする
		cancel_mouse_ges := 1
		;--------------- iniファイルで指定されたショートカットを実行する
		key := LRbuttonWheelUp
		Gosub SendKeyOrSearch
	}Else{
		;--------------- iniファイルで指定されたショートカットを実行する
		key := LbuttonWheelUp
		Gosub SendKeyOrSearch
	}
Return
;--------------- 左ボタンを押しながらのマウス拡張機能が実行されたとき
~LButton & WheelDown::
	;--------------- マウスホイール回転でウィンドウをアクティブにする
	If (ActvOnWheel == 1) {
		ActivateUnderMouseWindow()
	}
	;--------------- 左と右ボタンを押しながらマウス拡張機能が実行されたとき
	If (GetKeyState("RButton","p")) {
		;--------------- マウスジェスチャーキャンセル変数をオンにする
		cancel_mouse_ges := 1
		;--------------- iniファイルで指定されたショートカットを実行する
		key := LRbuttonWheelDn
		Gosub SendKeyOrSearch
	}Else{
		;--------------- iniファイルで指定されたショートカットを実行する
		key := LbuttonWheelDn
		Gosub SendKeyOrSearch
	}
Return
;--------------- 右ボタンを押しながらのマウス拡張機能が実行されたとき
~RButton & WheelUp::
~RButton & WheelDown::
	;--------------- マウスホイール回転でウィンドウをアクティブにする
	If (ActvOnWheel == 1) {
		ActivateUnderMouseWindow()
	}
	;--------------- マウスジェスチャー実行可能状態をオフにする
	enable_mouse_ges := 0
	;--------------- ホイール回転方向に応じて処理を変更する
	IfInString, A_ThisHotkey, WheelUp
	{
		;--------------- ホイールタイプをセット
		wheeltype := "WheelUp"
		;--------------- 送信キーをセット
		key := RbuttonWheelUp
	}Else{
		;--------------- ホイールタイプをセット
		wheeltype := "WheelDown"
		;--------------- 送信キーをセット
		key := RbuttonWheelDn
	}
	;--------------- 左と右ボタンを押しながらマウス拡張機能が実行されたとき
	If (GetKeyState("LButton","p")) {
		;--------------- マウスジェスチャーキャンセル変数をオンにする
		cancel_mouse_ges := 1
		;--------------- iniファイルで指定されたショートカットを実行する
		If (wheeltype == "WheelUp") {
			key := LRbuttonWheelUp
		}Else{
			key := LRbuttonWheelDn
		}
		Gosub SendKeyOrSearch
		Return
	}
	;--------------- タスクバー領域で実行されたか判定する
	If (RButtonDownlOnTaskbar == 1) {
		;--------------- タスクバー領域で実行されたときはホイール回転時の拡張コマンドを実行する
		;--------------- タスクトレイ上のホイール回転で音量変更
		If (ChangeVolumeOnTray == 1) {
			ChangeVolumeOnTray(wheeltype,WinCtrlClass)
		}
		;--------------- スタートボタン上のホイール回転ですべてのウィンドウを最小化/元に戻す
		If (EnableMinAllByWheelOnStBtn == 1) {
			MinAllByWheelOnStBtn(wheeltype,WinCtrlClass)
		}
		;--------------- タスクバーアイコン上のホイール回転で起動/最小化/元に戻す
		If (MinimizeByWheelOnTaskIcon == 1) {
			MinimizeByWheelOnTaskIcon(wheeltype,win_id,WinCtrlClass)
		}
	}Else{
		;--------------- タイトルバー上のホイール回転で最大化/リサイズ/最小化
		If (EnableResizeByWheel == 1) {
			;--------------- マウスホイール回転でウィンドウをアクティブにする
			If (ActvOnWheel == 1) {
				ActivateUnderMouseWindow()
			}
			;--------------- マウスカーソルがアクティブウィンドウのタイトルバーの上にあるか判定する
			Res := IsMouseOnActiveWinTitleBar()
			If (Res == True) {
				If (wheeltype == "WheelUp") {
					Gosub SubMaximizeActvWin
				}Else{
					Gosub SubMinimizeActvWin
				}
				Return
			}
		}
		;--------------- タスクバー領域以外で実行されたときは通常の拡張コマンドを実行する
		;--------------- iniファイルで指定されたショートカットを実行する
		Gosub SendKeyOrSearch
	}
Return
;--------------- 中ボタンを押しながらのマウス拡張機能が実行されたとき
~MButton & WheelUp::
	;--------------- マウスホイール回転でウィンドウをアクティブにする
	If (ActvOnWheel == 1) {
		ActivateUnderMouseWindow()
	}
	;--------------- iniファイルで指定されたショートカットを実行する
	key := MbuttonWheelUp
	Gosub SendKeyOrSearch
Return
;--------------- 中ボタンを押しながらのマウス拡張機能が実行されたとき
~MButton & WheelDown::
	;--------------- マウスホイール回転でウィンドウをアクティブにする
	If (ActvOnWheel == 1) {
		ActivateUnderMouseWindow()
	}
	;--------------- iniファイルで指定されたショートカットを実行する
	key := MbuttonWheelDn
	Gosub SendKeyOrSearch
Return
;--------------- X1ボタンを押しながらのマウス拡張機能が実行されたとき
XButton1 & WheelUp::
	;--------------- マウスホイール回転でウィンドウをアクティブにする
	If (ActvOnWheel == 1) {
		ActivateUnderMouseWindow()
	}
	;--------------- iniファイルで指定されたショートカットを実行する
	key := Xbutton1WheelUp
	Gosub SendKeyOrSearch
	;--------------- マウスジェスチャー起動後のX1クリック防止判定変数をセットする
	NoXbutton1 := 1
Return
;--------------- X1ボタンを押しながらのマウス拡張機能が実行されたとき
XButton1 & WheelDown::
	;--------------- マウスホイール回転でウィンドウをアクティブにする
	If (ActvOnWheel == 1) {
		ActivateUnderMouseWindow()
	}
	;--------------- iniファイルで指定されたショートカットを実行する
	key := Xbutton1WheelDn
	Gosub SendKeyOrSearch
	;--------------- マウスジェスチャー起動後のX1クリック防止判定変数をセットする
	NoXbutton1 := 1
Return
;--------------- X2ボタンを押しながらのマウス拡張機能が実行されたとき
XButton2 & WheelUp::
	;--------------- マウスホイール回転でウィンドウをアクティブにする
	If (ActvOnWheel == 1) {
		ActivateUnderMouseWindow()
	}
	;--------------- iniファイルで指定されたショートカットを実行する
	key := Xbutton2WheelUp
	Gosub SendKeyOrSearch
	;--------------- マウスジェスチャー起動後のX2クリック防止判定変数をセットする
	NoXbutton2 := 1
Return
;--------------- X2ボタンを押しながらのマウス拡張機能が実行されたとき
XButton2 & WheelDown::
	;--------------- マウスホイール回転でウィンドウをアクティブにする
	If (ActvOnWheel == 1) {
		ActivateUnderMouseWindow()
	}
	;--------------- iniファイルで指定されたショートカットを実行する
	key := Xbutton2WheelDn
	Gosub SendKeyOrSearch
	;--------------- マウスジェスチャー起動後のX2クリック防止判定変数をセットする
	NoXbutton2 := 1
Return
;--------------- Shiftキーを押しながらホイールで水平スクロール
~Shift & WheelUp::
~Shift & WheelDown::
	If (EnableHorScroll == 1) {
		;--------------- ホイールタイプをセット
		wheeltype := A_ThisHotkey
		;--------------- マウスホイール回転でウィンドウをアクティブにする
		If (ActvOnWheel == 1) {
			ActivateUnderMouseWindow()
		}
		;--------------- ホイール回転方向に応じて処理を変更する
		IfInString, A_ThisHotkey, WheelUp
		{
			Gosub SubMouseWhLeft
		}Else{
			Gosub SubMouseWhRight
		}
	}
Return
